Attribute VB_Name = "GEnumFonts"
'---------------------------------------------------------------------------------------
' Modul     : GEnumFonts
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Iteration ber Zeichenstze mittels CallBack-Funktion
'---------------------------------------------------------------------------------------

Option Explicit

'/ API Konstanten und Typen
Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

Public Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long        'Ab hier nur fr TrueTypeFonts!!!
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type

Public Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(1 To LF_FACESIZE) As Byte
End Type

Public Type ENUMLOGFONT
        elfLogFont As LOGFONT
        elfFullName(LF_FULLFACESIZE - 1) As Byte
        elfStyle(LF_FACESIZE - 1) As Byte
End Type

Public Type ENUMLOGFONT1
        elfLogFont As Long
        elfFullName(LF_FULLFACESIZE - 1) As Byte
        elfStyle(LF_FACESIZE - 1) As Byte
End Type

Public Enum EFontType
    NO_FONTTYPE = 0
    RASTER_FONTTYPE = &H1
    DEVICE_FONTTYPE = &H2
    TRUETYPE_FONTTYPE = &H4
End Enum

'---------------------------
'/ Aufgaben fr EnumFontFamProc (Bitmaske)
Public Enum EFontArrangement
    OutputList = 1
    GetNames = &H100
    GetFullNames = &H200
    GetStyle = &H400
End Enum

Public oEFnts As CEnumFonts

Public Function EnumFontFamProc( _
                                lpElf As ENUMLOGFONT, _
                                lpNtm As NEWTEXTMETRIC, _
                                ByVal FontType As EFontType, _
                                ByVal lParam As EFontArrangement) As Long
    
    If oEFnts Is Nothing Then
        '/ Abbruch
        EnumFontFamProc = 0
    Else
        '/ An die Klasse durchreichen
        Call oEFnts.EnumFontFamP(lpElf, lpNtm, FontType, lParam)
        '/ Weiter iterieren
        EnumFontFamProc = -1
    End If
End Function

